package de.hcinc.torasu.pipeline;

import de.hcinc.torasu.core.DataPackageable;
import de.hcinc.torasu.core.RenderContext;
import de.hcinc.torasu.core.RenderContext.RenderContextObject;
import de.hcinc.torasu.core.Renderable;
import de.hcinc.torasu.core.Target;
import de.hcinc.torasu.core.Target.TargetResult;
import de.hcinc.torasu.core.Renderable.RenderResult;
import de.hcinc.torasu.core.Renderable.RenderableData;
import de.hcinc.torasu.core.Renderable.ResultSettings;

/**The {@link ExecutionInterface} is an interface to run renders and task-executions. 
 */
public interface ExecutionInterface {
	
	/**Unpacks the RenderContextValue from an {@link RenderContextObject} and handles the noted transformations.
	 * 
	 * @param rctxo The {@link RenderContextObject} that has to be unpacked
	 * 
	 * @return The unpacked RenderContextValue (which is implemented as a {@link DataPackageable})
	 */
	public default DataPackageable unpackRenderContextValue(RenderContextObject rctxo) {
		return unpackRenderContextObject(rctxo, 1).getValue();
	}

	/**Unpacks the {@link RenderContextObject} and handles the noted transformations as far as possible with the described effort.
	 * 
	 * @param rctxo The {@link RenderContextObject} that has to be unpacked
	 * @param effort The effort that is going to be made to unpack the {@link RenderContextObject} <br>
	 * 0: Only Locally; 0&lt;x&lt;1: Effort index, the bigger the higher the effort; 1: Maximum effort, will throw an error if couldn't be unpacked
	 * 
	 * @return The (partially) unpacked {@link RenderContextObject}
	 */
	RenderContextObject unpackRenderContextObject(RenderContextObject rctxo, double effort);

	/**Starts building the execution of a Renderable, it can be referenced via the returned renderId 
	 * (NOTE: The defined segments here will limit what data/modifications/render-segments will be available - to select everything insert a null into segments-argument)
	 * 
	 * @param rnd The Renderable that should be rendered
	 * 
	 * @param segments The segments of the Renderable that should be rendered
	 */
	long buildRender(Renderable rnd, String[] segments);
	
	/**Fetch {@link RenderableData} from the Renderable that is currently getting built
	 * 
	 * @param renderId The render id that got returned from the initialization ({@link ExecutionInterface#buildRender(Renderable)})
	 * @param keys The keys of that {@link RenderableData} that should be fetched
	 * @param rctx The {@link RenderContext} where the data should be fetched
	 * 
	 * @return The {@link RenderableData} that has been requested
	 * 
	 * @see RenderableData
	 */
	RenderableData getRenderableData(long renderId, String[] keys, RenderContext rctx);

	/**Fetch identifiers of the RenderableModifiers that are promised to be able to get used
	 * 
	 * @param renderId The render id that got returned from the initialization ({@link ExecutionInterface#buildRender(Renderable)})
	 * @param modificationIdents The identifiers of the RenderableModifiers that should be checked
	 * @param rctx The {@link RenderContext} where the available modifiers should be fetched
	 * 
	 * @return A string array of the identifiers that are available
	 */
	String[] getModificationPromises(long renderId, String[] modificationIdents, RenderContext rctx);

	/**Enqueues the prepared render (that has been constructed via buildRender(Renderable rnd)) under the renderId with the RenderContext and ResultSettings to fetch the result later on (via fetchRenderResult(long renderId))
	 * 
	 * @param renderId The render id that got returned from the initialization ({@link ExecutionInterface#buildRender(Renderable)})
	 * @param rctx The {@link RenderContext} it should be rendered on
	 * @param rs The ResultSettings it should be rendered at
	 * @param prio The local priority of the render
	 * 
	 * @return the status of the enqueue operation
	 */
	int enqueueRender(long renderId, RenderContext rctx, ResultSettings rs, long prio);

	/**Directly Enqueues render of Renderable and returns the renderId to fetch the result later on
	 * 
	 * @param rend The Renderable that has to be enqueued
	 * @param rctx The {@link RenderContext} it should be rendered on
	 * @param rs The ResultSettings it should be rendered at
	 * @param prio The local priority of the render 
	 * 
	 * @return The renderId of the equeued render
	 */
	long enqueueRender(Renderable rend, RenderContext rctx, ResultSettings rs, long prio);

	/**Waits for the render to finish and returns result
	 * 
	 * @param renderId The renderId of the render (generated by {@link ExecutionInterface#buildRender(Renderable)} or {@link ExecutionInterface#enqueueRender(Renderable, RenderContext, ResultSettings, long)})
	 * @return The RenderResult of the render
	 */
	RenderResult fetchRenderResult(long renderId);

	/**Enqueues Target Execution returns the renderId to fetch the result later on
	 * 
	 * @param trgt The Target that should be executed
	 * @param prio The local priority of the render
	 * 
	 * @return The {@code targetId} to fetch the result later on
	 */
	long enqueueTarget(Target trgt, long prio); 

	/**Waits for the execution of the Target to finish and returns the TargetResult
	 * 
	 * @param targetId The target id (generated by {@link ExecutionInterface#enqueueTarget(Target, long)})
	 * 
	 * @return The result of the target-execution
	 */
	TargetResult fetchTargetResult(long targetId);

}
